
Imports System.Reflection
Imports System.ComponentModel
Namespace System

   Public Class AllConverter
      'Konvertiert alle mglichen Objekte von oder zu String. Verwendet hierfr ein Dictionary von
      '! TypeConvertern. 
      '(eindimensionale) Arrays kanner auch konvertieren (und bunkert die Element-Typen in einem 2.
      '! Dictionary)
      'Die Dictionaries helfen, die Anwendung von Reflection zu minimieren.

#Region "Singleton"
      Public Shared ReadOnly Instance As New AllConverter
      Private Sub New()
      End Sub
#End Region 'Singleton

      Private _Converters As New Dictionary(Of Type, TypeConverter)
      Private _ElementTypes As New Dictionary(Of Type, Type)
      Private _VBProvider As New Microsoft.VisualBasic.VBCodeProvider
      Private _StringType As Type = GetType(String)

      Private Sub AddToDictionaries(ByVal Tp As Type)
         If Tp.IsArray Then
            Dim TpEl As Type = Tp.GetElementType
            _ElementTypes.Add(Tp, TpEl)
            If Not _Converters.ContainsKey(TpEl) Then AddToDictionaries(TpEl)
         Else
            Dim Converter As TypeConverter = _VBProvider.GetConverter(Tp)
            If Not Converter.CanConvertTo(_StringType) Then
               Throw New LongMsgException("Can't convert '", Tp.Name, "' to 'String'!")
            ElseIf Not Converter.CanConvertFrom(_StringType) Then
               Throw New LongMsgException("Can't convert 'String' to '", Tp.Name, "'!")
            End If
            _Converters.Add(Tp, Converter)
         End If
      End Sub

      Private Function ArrayToString(ByVal Obj As Object) As String
         Dim Arr As Array = DirectCast(Obj, Array)
         Dim Entries(Arr.Length - 1) As String
         For I As Integer = 0 To Arr.Length - 1
            Entries(I) = Arr.GetValue(I).ToString
         Next
         Return String.Join("; ", Entries)
      End Function

      Public Overloads Function ToString(Of T)(ByVal Obj As T) As String
         Dim Tp As Type = GetType(T)
         If _ElementTypes.ContainsKey(Tp) Then
            Return ArrayToString(Obj)
         End If
         If _Converters.ContainsKey(Tp) Then
            Return _Converters(Tp).ConvertToString(Obj)
         End If
         AddToDictionaries(Tp)
         Return ToString(Of T)(Obj)
      End Function

      Private Function ArrayFromString(ByVal Tp As Type, ByVal sEntries As String) As Object
         Dim Entries() As String = Strings.Split(sEntries, "; ")
         Dim TpEl As Type = _ElementTypes(Tp)
         Dim Arr As Array = Array.CreateInstance(TpEl, Entries.Length)
         With _Converters(TpEl)
            For I As Integer = 0 To Entries.Length - 1
               Arr.SetValue(.ConvertFromString(Entries(I)), I)
            Next
         End With
         Return Arr
      End Function


      Public Function FromString(Of T)(ByVal S As String) As T
         Dim Tp As Type = GetType(T)
         If _ElementTypes.ContainsKey(Tp) Then
            Return DirectCast(ArrayFromString(Tp, S), T)
         End If
         If _Converters.ContainsKey(Tp) Then
            Return DirectCast(_Converters(Tp).ConvertFromString(S), T)
         End If
         AddToDictionaries(Tp)
         Return FromString(Of T)(S)
      End Function

   End Class 'AllConverter
End Namespace
