Namespace System.Collections.Generic

   Public Class ValuePair(Of T1, T2)
      Public Value1 As T1, Value2 As T2
      Public Sub New(ByVal Value1 As T1, ByVal Value2 As T2)
         Me.Value1 = Value1
         Me.Value2 = Value2
      End Sub
      Public Function AddTo(ByVal List As LookUpList(Of T1, T2)) As ValuePair(Of T1, T2)
         List.Add(Me)
         Return Me
      End Function
      Public Function AddTo(ByVal List As List(Of ValuePair(Of T1, T2))) As ValuePair(Of T1, T2)
         List.Add(Me)
         Return Me
      End Function
      Public Function InsertTo( _
              ByVal Index As Integer, _
              ByVal List As LookUpList(Of T1, T2)) As ValuePair(Of T1, T2)
         List.Insert(Index, Me)
         Return Me
      End Function
      Public Function RemoveFrom(ByVal List As LookUpList(Of T1, T2)) As ValuePair(Of T1, T2)
         List.Remove(Me)
         Return Me
      End Function

   End Class 'ValuePair

   Public Class LookupValueCollection(Of T)
      'Wrapper um eine List(Of T), um Hinzufgen/Entfernen zu verstecken
      Implements ICollection(Of T)

      Private _List As List(Of T)
      Friend Sub New(ByVal List As List(Of T))
         _List = List
      End Sub

#Region "Nicht implementiert"
      Private Sub Add(ByVal item As T) Implements ICollection(Of T).Add
      End Sub

      Private Sub Clear() Implements ICollection(Of T).Clear
      End Sub

      Private Function Remove(ByVal item As T) As Boolean Implements ICollection(Of T).Remove
         Throw New NotImplementedException
      End Function
#End Region 'Nicht implementiert


      Public Function Contains(ByVal Item As T) As Boolean Implements ICollection(Of T).Contains
         Return _List.Contains(Item)
      End Function

      Public Sub CopyTo(ByVal Array() As T, ByVal ArrayIndex As Integer) Implements ICollection(Of T).CopyTo
         _List.CopyTo(Array, ArrayIndex)
      End Sub

      Public ReadOnly Property Count() As Integer Implements ICollection(Of T).Count
         Get
            Return _List.Count
         End Get
      End Property

      Public ReadOnly Property IsReadOnly() As Boolean Implements ICollection(Of T).IsReadOnly
         Get
            Return DirectCast(_List, ICollection(Of T)).IsReadOnly
         End Get
      End Property

      Public Function GetEnumerator() As IEnumerator(Of T) Implements IEnumerable(Of T).GetEnumerator
         Return _List.GetEnumerator
      End Function

      Public Function GetEnumerator1() As IEnumerator Implements IEnumerable.GetEnumerator
         Return _List.GetEnumerator
      End Function

      Default Public Property Value(ByVal Index As Integer) As T
         Get
            Return _List(Index)
         End Get
         Set(ByVal NewValue As T)
            _List(Index) = NewValue
         End Set
      End Property
   End Class 'LookupValueCollection
   Public Class PairEnumerable(Of T1, T2)
      Implements IEnumerable(Of ValuePair(Of T1, T2))

      Private Enumerator As PairEnumerator

      Public Sub New(ByVal Enmbl0 As IEnumerable, ByVal Enmbl1 As IEnumerable)
         Enumerator = New PairEnumerator(Enmbl0, Enmbl1)
      End Sub

      Public Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
         Return Enumerator
      End Function

      Public Function GetEnumerator1() As IEnumerator(Of ValuePair(Of T1, T2)) Implements IEnumerable(Of ValuePair(Of T1, T2)).GetEnumerator
         Return Enumerator
      End Function

      Public Class PairEnumerator
         Implements IEnumerator(Of ValuePair(Of T1, T2))

         Private Enrt1, Enrt2 As IEnumerator

         Public Sub New(ByVal Enmbl1 As IEnumerable, ByVal Enmbl2 As IEnumerable)
            Enrt1 = Enmbl1.GetEnumerator
            Enrt2 = Enmbl2.GetEnumerator
         End Sub

         Public ReadOnly Property Current() As Object Implements IEnumerator.Current
            Get
               Return Current1
            End Get
         End Property

         Public Function MoveNext() As Boolean Implements IEnumerator.MoveNext
            Enrt2.MoveNext()
            Return Enrt1.MoveNext
         End Function

         Public Sub Reset() Implements IEnumerator.Reset
            Enrt1.Reset()
            Enrt2.Reset()
         End Sub

         Public ReadOnly Property Current1() As ValuePair(Of T1, T2) Implements IEnumerator(Of ValuePair(Of T1, T2)).Current
            Get
               Return New ValuePair(Of T1, T2)(DirectCast(Enrt1.Current, T1), DirectCast(Enrt2.Current, T2))
            End Get
         End Property

         Private disposedValue As Boolean = False        ' So ermitteln Sie berflssige Aufrufe

         ' IDisposable
         Protected Overridable Sub Dispose(ByVal disposing As Boolean)
            If Not Me.disposedValue Then
               If disposing Then
                  ' TODO: Nicht verwaltete Ressourcen freigeben, wenn sie explizit aufgerufen werden
               End If

               ' TODO: Gemeinsam genutzte nicht verwaltete Ressourcen freigeben
            End If
            Me.disposedValue = True
         End Sub

#Region " IDisposable Support "
         ' Dieser Code wird von Visual Basic hinzugefgt, um das Dispose-Muster richtig zu implementieren.
         Public Sub Dispose() Implements IDisposable.Dispose
            ' ndern Sie diesen Code nicht. Fgen Sie oben in Dispose(ByVal disposing As Boolean) Bereinigungscode ein.
            Dispose(True)
            GC.SuppressFinalize(Me)
         End Sub
#End Region

      End Class 'PairEnumerator

   End Class 'PairEnumerable

   Public Class LookUpList(Of T1, T2)
      Implements IList(Of ValuePair(Of T1, T2))

      Protected _List1 As New List(Of T1)
      Protected _List2 As New List(Of T2)
      Protected _Values1 As New LookupValueCollection(Of T1)(_List1)
      Protected _Values2 As New LookupValueCollection(Of T2)(_List2)
      Protected _Enumerable As PairEnumerable(Of T1, T2)

#Region "Nicht implementiert"
      Private Function Contains(ByVal item As ValuePair(Of T1, T2)) As Boolean Implements ICollection(Of ValuePair(Of T1, T2)).Contains
         Throw New NotImplementedException
      End Function

      Private Sub CopyTo(ByVal array() As ValuePair(Of T1, T2), ByVal arrayIndex As Integer) Implements ICollection(Of ValuePair(Of T1, T2)).CopyTo
         Throw New NotImplementedException
      End Sub

      Private Function IndexOf(ByVal item As ValuePair(Of T1, T2)) As Integer Implements IList(Of ValuePair(Of T1, T2)).IndexOf
         Throw New NotImplementedException
      End Function

      Private Property Item(ByVal index As Integer) As ValuePair(Of T1, T2) Implements IList(Of ValuePair(Of T1, T2)).Item
         Get
            Return Nothing
         End Get
         Set(ByVal value As ValuePair(Of T1, T2))

         End Set
      End Property

#End Region 'Nicht implementiert

      Public Sub New()
         If GetType(T1).Equals(GetType(T2)) Then
            Throw New ArgumentException(String.Format( _
                "Type1 '{0}' mu sich von Type2 '{1}' unterscheiden", _
                GetType(T1).Name, GetType(T2).Name))
         End If
      End Sub

      Private Function GetEnumerator() As IEnumerator(Of ValuePair(Of T1, T2)) Implements IEnumerable(Of ValuePair(Of T1, T2)).GetEnumerator
         _Enumerable = New PairEnumerable(Of T1, T2)(_Values1, _Values2)
         Return _Enumerable.GetEnumerator1
      End Function

      Private Function GetEnumerator1() As IEnumerator Implements IEnumerable.GetEnumerator
         Return GetEnumerator()
      End Function

      Public Sub Clear() Implements ICollection(Of ValuePair(Of T1, T2)).Clear
         _List1.Clear()
         _List2.Clear()
      End Sub

      Public ReadOnly Property Count() As Integer Implements ICollection(Of ValuePair(Of T1, T2)).Count
         Get
            Return _List1.Count
         End Get
      End Property

      Public ReadOnly Property IsReadOnly() As Boolean Implements ICollection(Of ValuePair(Of T1, T2)).IsReadOnly
         Get
            Return False
         End Get
      End Property

      Public Sub RemoveAt(ByVal Index As Integer) Implements IList(Of ValuePair(Of T1, T2)).RemoveAt
         _List1.RemoveAt(Index)
         _List2.RemoveAt(Index)
      End Sub

      Public Function Remove(ByVal item As T1) As Boolean
         RemoveAt(_List1.IndexOf(item))
         Return True
      End Function
      Public Function Remove(ByVal item As T2) As Boolean
         RemoveAt(_List2.IndexOf(item))
         Return True
      End Function
      Public Function Remove(ByVal item As ValuePair(Of T1, T2)) As Boolean Implements ICollection(Of ValuePair(Of T1, T2)).Remove
         Return Remove(item.Value1)
      End Function

      Public ReadOnly Property Values1() As LookupValueCollection(Of T1)
         Get
            Return _Values1
         End Get
      End Property

      Default Public Property Value(ByVal Key1 As T1) As T2
         Get
            Return _List2(_List1.IndexOf(Key1))
         End Get
         Set(ByVal Value As T2)
            _List2(_List1.IndexOf(Key1)) = Value
         End Set
      End Property

      Default Public Property Value(ByVal Key2 As T2) As T1
         Get
            Return _List1(_List2.IndexOf(Key2))
         End Get
         Set(ByVal Value As T1)
            _List1(_List2.IndexOf(Key2)) = Value
         End Set
      End Property


      Public Function IndexOf(ByVal Value1 As T1) As Integer
         Return _List1.IndexOf(Value1)
      End Function
      Public Function IndexOf(ByVal Value2 As T2) As Integer
         Return _List2.IndexOf(Value2)
      End Function

      Public ReadOnly Property Values2() As LookupValueCollection(Of T2)
         Get
            Return _Values2
         End Get
      End Property

      Public Sub Insert(ByVal index As Integer, ByVal item As ValuePair(Of T1, T2)) Implements IList(Of ValuePair(Of T1, T2)).Insert
         With item
            _List1.Insert(index, .Value1)
            _List2.Insert(index, .Value2)
         End With
      End Sub

      Public Sub Add(ByVal item As ValuePair(Of T1, T2)) Implements ICollection(Of ValuePair(Of T1, T2)).Add
         With item
            _List1.Add(.Value1)
            _List2.Add(.Value2)
         End With
      End Sub

      Public Function Add(ByVal Value1 As T1, ByVal Value2 As T2) As ValuePair(Of T1, T2)
         Add = New ValuePair(Of T1, T2)(Value1, Value2)
         Add(Add)
      End Function

      Public Function Insert( _
              ByVal Index As Integer, _
              ByVal Value1 As T1, _
              ByVal Value2 As T2) As ValuePair(Of T1, T2)
         Insert = New ValuePair(Of T1, T2)(Value1, Value2)
         Insert(Index, Insert)
      End Function


   End Class 'LookUpList
End Namespace
