Namespace System.Collections.Generic

   Public Class clsTreeEnumerable

      Implements IEnumerable
      'mit VB7 entwickelt
      'Vermittels der Implementierung der Schnittstelle System.Collections.IEnumerable werden die
      '! Verzweigungsknoten jedweder hierarchischen Datenstruktur der Reihe nach ausgegeben 
      '!(die Hierarchie wird flach gemacht), soda die Knoten mit For-Each bzw. .GetEnumerator()
      '! ansprechbar sind.

      Private TreeEnumerator As clsTreeEnumerator
      Private ArrList As ArrayList

      Public Sub New( _
              ByVal Root As Object, _
              ByVal EnumerableRoot As IEnumerable, _
              Optional ByVal CoRoot As Object = Nothing)
         MyClass.New(EnumerableRoot, CoRoot)
         TreeEnumerator.Root = Root
      End Sub

      Public Sub New( _
              ByVal EnumerableRoot As IEnumerable, _
              Optional ByVal CoRoot As Object = Nothing)
         Dim Obj As IEnumerator = EnumerableRoot.GetEnumerator
         Dim RecursiveProperty As String = Nothing
         If Obj.MoveNext() Then
            RecursiveProperty = GetRecPropName(Obj.Current, EnumerableRoot)
         End If
         TreeEnumerator = New clsTreeEnumerator(EnumerableRoot, RecursiveProperty, CoRoot)
      End Sub

      Public Sub New( _
              ByVal EnumerableRoot As IEnumerable, _
              ByVal RecursiveProperty As String, _
              Optional ByVal CoRoot As Object = Nothing)
         TreeEnumerator = New clsTreeEnumerator(EnumerableRoot, RecursiveProperty, CoRoot)
      End Sub

      Public Sub New( _
              ByVal Root As Object, _
              ByVal RecursiveProperty As String, _
              Optional ByVal CoRoot As Object = Nothing)
         TreeEnumerator = New clsTreeEnumerator(Root, RecursiveProperty, CoRoot)
      End Sub

      Private Function GetRecPropName(ByVal oParent As Object, ByVal oEnmbl As Object) As String
         GetRecPropName = ""
         Dim EnumerableTypeName As String = oEnmbl.GetType.Name
         Dim Msgs As New System.Collections.Generic.List(Of String)
         Select Case oEnmbl.GetType.Name
            Case "String", "__ComObject"
               Throw New Exception("Typ '" & oEnmbl.GetType.Name & "' kann nicht verarbeitet werden.")
         End Select
         For Each Mmb As Reflection.MethodInfo In oParent.GetType.GetMethods
            With Mmb
               If .Name.IndexOf("_"c) < 0 Then
                  If .GetParameters.GetUpperBound(0) < 0 Then
                     If .ReturnType.Name = EnumerableTypeName Then
                        If GetRecPropName = "" Then
                           GetRecPropName = Mmb.Name
                        Else
                           Throw New NotUniqueException( _
                               "Mmb", oParent.GetType.GetMethods, "rekursive Properties", 2)
                        End If
                     End If
                  End If
               End If
            End With
         Next
         For Each Mmb As Reflection.PropertyInfo In oParent.GetType.GetProperties
            With Mmb
               If .GetIndexParameters.GetUpperBound(0) < 0 Then
                  If .PropertyType.Name = EnumerableTypeName Then
                     If GetRecPropName = "" Then
                        GetRecPropName = Mmb.Name
                     Else
                        Throw New NotUniqueException( _
                            "Mmb", oParent.GetType.GetMethods, "rekursive Properties", 2)
                     End If
                  End If
               End If
            End With
         Next
         If GetRecPropName = "" Then
            Throw New NotUniqueException( _
                "Mmb", oParent.GetType.GetMethods, "rekursive Properties", 0)
         End If
      End Function

      Public ReadOnly Property ToArrayList() As ArrayList
         Get
            If ArrList Is Nothing Then
               ArrList = New ArrayList
               Dim Enmrt As IEnumerator = Me.GetEnumerator
               While Enmrt.MoveNext
                  ArrList.Add(Enmrt.Current)
               End While
            End If
            Return ArrList
         End Get
      End Property

      Public Shared ReadOnly Property ToArrayList(ByVal Enmbl As IEnumerable) As ArrayList
         Get
            Return New clsTreeEnumerable(Enmbl).ToArrayList
         End Get
      End Property

      Public ReadOnly Property CurrentDepth() As Integer
         Get
            Return TreeEnumerator.CurrentDepth
         End Get
      End Property

      Public Property Skip() As Boolean
         Get
            Return TreeEnumerator.Skip
         End Get
         Set(ByVal Value As Boolean)
            TreeEnumerator.Skip = Value
         End Set
      End Property


      Public Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
         TreeEnumerator.Reset()
         Return TreeEnumerator
      End Function

      Public Property CoCurrent() As Object
         Get
            Return TreeEnumerator.CoCurrents.Peek
         End Get
         Set(ByVal Value As Object)
            TreeEnumerator.CoCurrents.Push(Value)
         End Set
      End Property


      Public Class clsTreeEnumerator
         'clsTreeEnumerable.GetEnumerator() gibt ein Objekt dieser Klasse zurck. Man kann sie auch in
         '! clsTreeEnumerable hineinschachteln, um die Kapselung auf die Spitze zu treiben
         Implements IEnumerator

         Private ParentEnumerators As Stack  'Da der Tree iterativ (statt rekursiv) durchgegangen wird,
         '!                                    sind hier die Enumeratoren der Parent-Nodes zu speichern
         Private EnrtCurr As IEnumerator
         Private RecursiveProperty As String                 'Dadurch, da die rekursive Property (z.B.
         '!     "DirectoryInfo.GetDirectories" oder "TreeNode.Nodes") mitgeliefert werden mu, kann der
         '!                            clsTreeEnumerable hierarchische Strukturen aller Art verarbeiten
         Private GiveRoot As Boolean  'gibt an, da der Root-Node nach dem 1. .MoveNext ausgegeben wird
         Public Root As Object                         'entweder wird hier der Root-Node gespeichert...
         Private Enumerable As IEnumerable     '... oder hier die rekursive Property der obersten Ebene


         Public CoCurrents As Stack   'bunkert ggfs. die Enumerablen einer aufzubauenden hierarchischen
         '!                                     Struktur (z.B. die TreeNodeCollections eines Treeviews)
         Private CoRoot As Object                                          'Root-Objekt der Co-Struktur
         Public Skip As Boolean  'gibt an, ob beim nchsten MoveNext aus dem akt. Knoten heraussprungen
         '!                                                                                        wird

         Public Sub New( _
                 ByVal EnumerableRoot As IEnumerable, _
                 ByVal RecursiveProperty As String, _
                 ByVal CoRoot As Object)
            'fr eine Ausgabe nur der Root-Children
            If EnumerableRoot Is Nothing Then
#If DEBUG Then                          'AddIns verabschieden sich ohne Fehlermeldung, also stoppen!
               Stop
#Else
                Throw New ArgumentNullException("Enumerable", "clsTreeEnumerator.New()")
#End If
            End If
            Me.RecursiveProperty = RecursiveProperty
            Me.Enumerable = EnumerableRoot
            Me.CoRoot = CoRoot
         End Sub


         Public Sub New( _
                 ByVal Root As Object, _
                 ByVal RecursiveProperty As String, _
                 ByVal CoRoot As Object)
            'fr eine Ausgabe inclusive des Root-Objektes
            MyClass.New( _
                DirectCast(CallByName(Root, RecursiveProperty, CallType.Get), IEnumerable), _
                RecursiveProperty, _
                CoRoot)
            'Me.RecursiveProperty = RecursiveProperty
            Me.Root = Root
            'Me.CoRoot = CoRoot
         End Sub


         Public Sub Reset() Implements IEnumerator.Reset
            ParentEnumerators = New Stack
            GiveRoot = Root IsNot Nothing
            ParentEnumerators.Push(Enumerable.GetEnumerator)
            If Not CoRoot Is Nothing Then
               CoCurrents = New Stack
               CoCurrents.Push(CoRoot)
            End If
         End Sub


         Public ReadOnly Property CurrentDepth() As Integer
            Get
               Return ParentEnumerators.Count - 1
            End Get
         End Property

         Public Overridable Function MoveNext() As Boolean Implements IEnumerator.MoveNext
            If GiveRoot Then Return True 'Im 1. Aufruf wird ggfs. noch gar nicht gemoved!
            'Das MoveNext-Prinzip: 
            'Stack leer -> Ende der Iteration ("Pseudo-Rekursion")
            'Oberstes Objekt moveable (EnrtCurr.MoveNext = True) -> dessen Children auf den Stack
            '! (Pseudo-Rekursion vertiefen), EnrtCurr ist dann richtig eingestellt fr die Current()-
            '! Property
            'Solange Oberstes Objekt nicht moveable (EnrtCurr.MoveNext = False) -> Objekt runter vom
            '! Stack
            If Skip Then                                                 'aussem akt. Knoten raushopfen
               Skip = False
               ParentEnumerators.Pop()   'CoCurrents darf nicht mitgepoppt werden, da ParentEnumerators
               '!                            in der While-Schleife sich gleich wieder einen drauf-pusht
            End If
            While ParentEnumerators.Count > 0
               EnrtCurr = DirectCast(ParentEnumerators.Peek, IEnumerator)
               If EnrtCurr.MoveNext Then
                  Dim oEnumerable As Object = CallByName( _
                      EnrtCurr.Current, RecursiveProperty, CallType.Get)
                  If oEnumerable IsNot Nothing Then
                     ParentEnumerators.Push(DirectCast(oEnumerable, IEnumerable).GetEnumerator)
                  End If
                  Return True                                                        'Es gibt noch was!
               Else
                  If Not CoRoot Is Nothing Then CoCurrents.Pop()
                  ParentEnumerators.Pop()
               End If
            End While
            Return False                                              'Stack leer -> Ende der Iteration
         End Function

         Public ReadOnly Property Current() As Object Implements IEnumerator.Current
            'Gibt einen VerzweigungsKnoten des Trees zurck
            Get
               'If Not CoRoot Is Nothing Then Skip = True
               If GiveRoot Then
                  GiveRoot = False
                  Return Root
               Else
                  Return EnrtCurr.Current
               End If
            End Get
         End Property


      End Class 'clsTreeEnumerator

   End Class 'clsTreeEnumerable
End Namespace