Imports System.Xml

Namespace System.Windows.Forms

   Public Module modForms

      Private Delegate Function CallByNameDelegate( _
              ByVal Obj As Object, _
              ByVal MemberName As String, _
              ByVal Args() As Object, _
              ByVal Calltype As Microsoft.VisualBasic.CallType) As Object
      Private Function CallThreadSafe( _
              ByVal Obj As Object, _
              ByVal MemberName As String, _
              ByVal Args() As Object, _
              ByVal Calltype As Microsoft.VisualBasic.CallType) As Object
         If Args.Length = 0 Then
            Return CallByName(Obj, MemberName, Calltype)
         Else
            Return CallByName(Obj, MemberName, Calltype, Args)
         End If
      End Function
      Public Function CallThreadSafe( _
              ByVal Ctl As Control, _
              ByVal MemberName As String, _
              ByVal Calltype As Microsoft.VisualBasic.CallType, _
              ByVal ParamArray Args() As Object) As Object
         Static Dlg As New CallByNameDelegate(AddressOf CallThreadSafe)
         Return Ctl.Invoke(Dlg, New Object() {Ctl, MemberName, Args, Calltype})
      End Function
      Public Function CallThreadSafe( _
              ByVal Ctl As Control, _
              ByVal Obj As Object, _
              ByVal MemberName As String, _
              ByVal Calltype As Microsoft.VisualBasic.CallType, _
              ByVal ParamArray Args() As Object) As Object
         Static Dlg As New CallByNameDelegate(AddressOf CallThreadSafe)
         Return Ctl.Invoke(Dlg, New Object() {Obj, MemberName, Args, Calltype})
      End Function

      Public Function MousePosToClient( _
              ByVal Ctl As Control, _
              Optional ByVal ThreadSafe As Boolean = False) As Point
         Return MousePosToClient(Ctl, Control.MousePosition, ThreadSafe)
      End Function
      Private Delegate Function PointToClientDelegate( _
              ByVal Ctl As Control, _
              ByVal ScreenMousePos As Point, _
              ByVal ThreadSafe As Boolean) As Point
      Public Function MousePosToClient( _
              ByVal Ctl As Control, _
              ByVal ScreenMousePos As Point, _
              Optional ByVal ThreadSafe As Boolean = False) As Point
         'funny brainfuck for get it threadsafe!
         Static Dlg As New PointToClientDelegate(AddressOf MousePosToClient)
         If ThreadSafe Then
            Return DirectCast(Ctl.Invoke(Dlg, New Object() {Ctl, ScreenMousePos, False}), Point)
         Else
            Return Ctl.PointToClient(ScreenMousePos)
         End If
      End Function


      <Obsolete("Much better use MenustripEx")> _
      Public Sub InitMenuClicks(ByVal Strip As ToolStrip, ByVal ClickHandler As EventHandler)
         'leitet die Clicks aller ToolStripMenuItem auf den ClickHandler
         'generiert (ins Debug-Fenster) den erforderlichen Code des Selects des ClickHandler
         'Die Case-Unterscheidung erfolgt anhand der ToolStripMenuItem.Text-Eigenschaft
         If Strip Is Nothing Then Return
         Dim SelectCode As New List(Of String)
         SelectCode.Add("Private Sub MenuClicks(ByVal sender As Object, ByVal e As EventArgs)")
         SelectCode.Add("select case Fullname(sender, ""OwnerItem"", ""Text"", ""\"")")
         For Each Itm As ToolStripItem In Strip.Items
            InitMenuClicksRecurse(Itm, SelectCode, ClickHandler)
         Next
         SelectCode.Add("End select")
         SelectCode.Add("End Sub")
         Debug.WriteLine(String.Join(vbNewLine, SelectCode.ToArray))
      End Sub
      Private Sub InitMenuClicksRecurse( _
              ByVal Itm As ToolStripItem, _
              ByRef SelectCode As List(Of String), _
              ByVal ClickHandler As EventHandler)
         If TypeOf Itm Is ToolStripMenuItem Then
            With DirectCast(Itm, ToolStripMenuItem)
               If Not .HasDropDownItems Then
                  AddHandler .Click, ClickHandler
                  SelectCode.Add(String.Format( _
                      "case ""{0}"":", _
                      Fullname(Itm, "OwnerItem", "Text", "\").Replace(""""c, """""")))
               End If
               For Each itmRecurse As ToolStripItem In .DropDownItems
                  InitMenuClicksRecurse(itmRecurse, SelectCode, ClickHandler)
               Next
            End With
         End If
      End Sub

      Public Function AppendElement(ByVal ndParent As XmlNode, ByVal ElName As String, ByVal ParamArray AttributeTexts() As String) As XmlElement
         'XmlElement erzeugen und in ndParent einhngen, das neue XmlElement zurckgeben
         Dim XDoc As XmlDocument
         If ndParent.NodeType = XmlNodeType.Document Then      'ndParent ist das OwnerDocument selbst
            XDoc = DirectCast(ndParent, XmlDocument)
         Else
            XDoc = ndParent.OwnerDocument
         End If
         AppendElement = CreateCompleteElement(XDoc, ElName, AttributeTexts)                        '
         '!                                                                XDoc.CreateElement(ElName)
         ndParent.AppendChild(AppendElement)
      End Function

      Function CreateCompleteElement( _
              ByVal XMLDoc As XmlDocument, _
              ByVal sName As String, _
              ByVal ParamArray AttributeTexts() As String) As XmlElement
         'erzeugt ein XmlElement mit mehreren Attributen
         CreateCompleteElement = XMLDoc.CreateElement(sName)
         For Each Entry As String In AttributeTexts
            Dim Splitted As String() = Entry.Split("="c)
            CreateCompleteElement.SetAttribute(Splitted(0), Splitted(1))
         Next
      End Function

   End Module
End Namespace
