
Public Class clsTreeListViewNode
   Inherits clsTreeNodeEx
   Protected _TLV As uclTreeListview
   Protected _Texts As String() = New String() {}
   Private mRedrawID As Integer = Integer.MinValue

   Public Sub New( _
         ByVal TLV As uclTreeListview, Optional ByVal Nodes As TreeNodeCollection = Nothing)
      _TLV = TLV
      MyBase._TV = _TLV.TreeView
      ReDim _Texts(_TLV.Columns.Count - 1)
      For I As Integer = 0 To _Texts.Length - 1
         _Texts(I) = ""
      Next
      If Nodes Is Nothing Then Nodes = _TLV.TreeView.Nodes
      MyBase.AddTo(Nodes)
   End Sub
   Public Sub New(ByVal Parent As clsTreeListViewNode)
      MyClass.New(Parent._TLV, Parent.Nodes)
   End Sub
   Public Shared Shadows Function [New](ByVal TLV As uclTreeListview) As clsTreeListViewNode
      Return New clsTreeListViewNode(TLV)
   End Function
   Public Shared Shadows Function [New]( _
         ByVal Parent As clsTreeListViewNode) As clsTreeListViewNode
      Return New clsTreeListViewNode(Parent)
   End Function
   Public Shadows Function AddTo(ByVal Nodes As TreeNodeCollection) As clsTreeListViewNode
      MyBase.AddTo(Nodes)
      Return Me
   End Function
   Public Shadows ReadOnly Property Instance() As clsTreeListViewNode
      Get
         Return Me
      End Get
   End Property

   Public Sub UpdateBaseText( _
         ByVal RedrawID As Integer, ByVal TableFormatter As clsTableFormatter)
      If mRedrawID = RedrawID Then Exit Sub
      mRedrawID = RedrawID
      MyBase.Text = TableFormatter.ToLine(_Texts)
   End Sub

   Public Shadows Property Text(ByVal Index As Integer) As String
      Get
         Return _Texts(Index)
      End Get
      Set(ByVal value As String)
         If _Texts(Index) = value Then Return
         _Texts(Index) = value
         mRedrawID = Integer.MinValue
         _TV.Invalidate()
      End Set
   End Property
   Public Shadows Property Text(ByVal Key As TreelistviewColumn) As String
      Get
         Return _Texts(_TLV.Columns.IndexOf(Key))
      End Get
      Set(ByVal value As String)
         Me.Text(_TLV.Columns.IndexOf(Key)) = value
      End Set
   End Property
End Class
