Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Collections.Generic

Public Class HierarchicalRegexPattern
   Inherits HierarchicalText(Of clsGroupInfo)

   Private Shared _RecordingGroupRegex As New Regex( _
       "^(\?<(?<Name>\w+)|(?<NoName>[^?]))", _
       RegexOptions.Compiled)

   Private _GroupInfos As New List(Of clsGroupInfo)

   Public Function Pattern(ByVal Value As String) As HierarchicalRegexPattern
      MyBase.Text(Value)          'baue einen Tree anhand der gegebenen Verschachtelung der Klammern
      'Regex kennt auch nicht aufzeichnende Groups, diese tauchen im Match nicht auf, mssen daher
      '! auch aus unserem Tree herausgelscht werden.
      Dim ToDelete As New List(Of clsNode(Of clsGroupInfo))       'Frs Lschen nicht aufzeichnender
      '!                                               Gruppen aus dem GroupInfo-Tree (MyBase._Root)
      For Each GroupNode As clsNode(Of clsGroupInfo) In MyBase._Root.AllChildren
         With _RecordingGroupRegex.Match(GroupNode.Content.Value)
            If .Success Then
               GroupNode.Content.Name = .Groups("Name").Value
            Else
               ToDelete.Add(GroupNode)                                           'Lschung vormerken
            End If
         End With
      Next
      ToDelete.Reverse()                      '"Bottom-up-Lschung" - untergeordnete Segmente zuerst
      For Each GroupNode As clsNode(Of clsGroupInfo) In ToDelete
         GroupNode.Delete()
      Next
      FillGroupInfosSortedInMatchOrder()
      Return Me
   End Function

   Private Sub FillGroupInfosSortedInMatchOrder()
      'Die Groups eines Regex-Matches sind speziell sortiert: erst die unbenannten Groups in der
      '! Reihenfolge der ffnenden Klammern, dann die benannten Groups, ebenfalls in Reihenfolge der
      '! ffnenden Klammern
      Dim NamedInfos As New List(Of clsGroupInfo)
      For Each Info As clsNode(Of clsGroupInfo) In MyBase._Root.AllChildren(WithRoot:=True)
         If Info.Content.Name <> "" Then
            NamedInfos.Add(Info.Content)
         Else
            _GroupInfos.Add(Info.Content)
         End If
      Next
      _GroupInfos.AddRange(NamedInfos)
   End Sub
   Public ReadOnly Property Groupinfos() As List(Of clsGroupInfo)
      Get
         Return _GroupInfos
      End Get
   End Property

End Class