Imports System.Text
Imports System.Text.RegularExpressions

Public Class HierarchicalText(Of InfoType As {INodeContent(Of InfoType), clsSegmentInfo, New})
   'baut aus einem verschachtelten Klammerausdruck einen Tree von clsSegmentInfo-Objekten (bzw.
   '! Derivaten) auf, die die einzelnen Klammern beschreiben (Index, Length, Value). Die Klammern
   '! selbst sind im beschriebenen Textabschnitt nicht enthalten
   Protected _Root As New clsNode(Of InfoType)

   'Dieser Regex ignoriert Klammern, vor denen das Escape-Zeichen "\" steht (Genau: vor denen eine unerade Anzahl von "\" steht)
   Private Shared _BrackFindRegex As New Regex( "(?<=(^|[^\\](\\\\)*))[\(\)]")   
   Private _TextBase As StringBuilder

   Public Function Text(ByVal Value As String) As HierarchicalText(Of InfoType)
      _TextBase = New StringBuilder(Value)
      Dim Info As New InfoType
      Info.SetTextbase(_TextBase).SetIndex(0).SetLength(Value.Length).SetRelativeIndex(0)
      _Root.Content(Info)
      Dim Current As clsNode(Of InfoType) = _Root
      For Each Mt As Match In _BrackFindRegex.Matches(Value)
         Select Case Mt.Value
            Case "("
               With New clsNode(Of InfoType)
                  Info = New InfoType
                  'Index hinter die "(" setzen. RelativeIndex bezeichnet die Position relativ zur
                  '! Position des Parents
                  Info.SetTextbase(_TextBase). _
                      SetIndex(Mt.Index + 1). _
                      SetRelativeIndex(Mt.Index - Current.Content.Index)
                  .Content(Info)
                  Current = .AddTo(Current)
               End With
            Case ")"
               With Current.Content
                  .SetLength(Mt.Index - .Index)
               End With
               Current = Current.Parent
            Case Else
         End Select
      Next
      Return Me
   End Function
   Public ReadOnly Property Root() As clsNode(Of InfoType)
      Get
         Return _Root
      End Get
   End Property
   Public ReadOnly Property TextBase() As StringBuilder
      Get
         Return _TextBase
      End Get
   End Property

End Class