Imports System.Runtime.CompilerServices
Imports System.Text.RegularExpressions

Partial Class RegexDataSet

   Public EventDisabler As New ActionFrame( _
      Sub()
         RemoveHandler RgxOption.ColumnChanged, AddressOf RgxOption.RgxOptionDataTable_ColumnChanged
      End Sub, _
      Sub()
         AddHandler RgxOption.ColumnChanged, AddressOf RgxOption.RgxOptionDataTable_ColumnChanged
      End Sub)

   Partial Class SampleDataTable

      Private Sub SampleDataTable_SampleRowChanging(ByVal sender As System.Object, ByVal e As SampleRowChangeEvent) Handles Me.SampleRowChanging
         If e.Action = DataRowAction.Add Then
            Dim i = 9
         End If
      End Sub

   End Class

   Partial Class RgxOptionDataTable

      Private Function CalculateOption() As RegexOptions
         Dim opt = RegexOptions.None
         For Each rwOpt In Me
            If rwOpt.Checked Then
               opt = opt Or DirectCast(rwOpt.Value, RegexOptions)
            End If
         Next
         Return opt
      End Function

      Friend Sub RgxOptionDataTable_ColumnChanged(ByVal sender As Object, ByVal e As DataColumnChangeEventArgs)
         If e.Column IsNot columnChecked Then Return
         Dim rwSample = e.Row.CastX(Of RgxOptionRow)().SampleRow
         If rwSample.Null OrElse rwSample.RowState = DataRowState.Detached Then Return
         rwSample.RgxOption = CalculateOption()
      End Sub

      Public Sub InitOptions()
         Dim opts = New List(Of RegexOptions)(DirectCast([Enum].GetValues(GetType(RegexOptions)), RegexOptions()))
         opts.Remove(RegexOptions.None)
         opts.Remove(RegexOptions.Compiled)
         For Each opt In opts
            AddRgxOptionRow(opt, opt.ToString, False, Nothing)
         Next
      End Sub

      Private Sub RgxOptionDataTable_Initialized(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Initialized
         InitOptions()
      End Sub
   End Class

End Class
Public Module DataTableX
   <Extension()>
   Public Function Dts(ByVal table As DataTable) As RegexDataSet
      Return DirectCast(table.DataSet, RegexDataSet)
   End Function
End Module
