Imports TreeListview
Imports System.Text.RegularExpressions
Imports RegexTester.RegexDataSet
Imports System.Xml
Imports System.IO
Imports System.Collections.Generic
Imports Microsoft.VisualBasic
Imports System.Text

Public Class frmRegexTester
   Private _Reference As New FileInfo("Data\RgxReference.doc")
   Private _Manual As New FileInfo("Data\Manual.doc")

   Public Sub New()
      InitializeComponent()
      Me.rtbComments.SelectionIndent = Me.rtbSearchpattern.IndentSize \ 2
      Dim dataFile As New FileInfo(My.Settings.SampleFile)
      SaveFileDialog1.FileName = dataFile.FullName
      SaveFileDialog1.InitialDirectory = dataFile.Directory.FullName
      DTS.EventDisabler.ExecuteExit()
      Reload()
      AddHandler Me.FormClosing, AddressOf frmRegexTester_FormClosing
   End Sub

   Private Sub ResetFonts()
      For Each rtb In New RichTextBox() {rtbComments, rtbSearchpattern, rtbReplacepattern, rtbReplaceResult, rtbToParse}
         rtb.SelectAll()
         rtb.SelectionFont = rtb.Font
         rtb.SelectionColor = rtb.ForeColor
         rtb.SelectionBackColor = rtb.BackColor
      Next
   End Sub

   Private Sub MenuStripEx1_ItemClick( _
           ByVal Sender As Object, _
           ByVal e As MenuStripEx.ItemClickEventArgs) _
           Handles MenuStripEx1.ItemClick
      Select Case e.FullCaption
         Case "&File\&Reload"
            Reload()
         Case "&File\&Change..."
            If Me.SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
               Reload()
            End If
         Case "&File\&Save"
            Save()
         Case "&File\&Quit - no Save"
            RemoveHandler Me.FormClosing, AddressOf frmRegexTester_FormClosing
            Me.Close()
         Case "&Parse!"
            Parse()
         Case "ResetF&onts"
            ResetFonts()
         Case "E&xport"
            Export()
         Case "&Reference"
            Try
               Process.Start(_Reference.FullName)
            Catch ex As Exception
               NewMessageBox( _
                  "Fehler beim ffnen der Datei\n'", _
                  _Reference.FullName, _
                  "'\n", _
                  ex.ToString).Show()
            End Try
         Case "&Manual"
            Try
               Process.Start(_Manual.FullName)
            Catch ex As Exception
               NewMessageBox( _
                  "Fehler beim ffnen der Datei\n'", _
                  _Manual.FullName, _
                  "'\n", _
                  ex.ToString).Show()
            End Try
         Case "&CloneSample"
            CloneSampleRow()
      End Select
   End Sub

   Private Sub Export()
      Dim txt = String.Concat(Me.rtbSearchpattern.Text.Split(CrLf.ToCharArray))
      With New StringList
         .AddLine("the pure Regex-Search-Pattern (c#: enclose in @""...""):")
         .AddLine(txt)
         .AddLine()
         .AddLine("elaborated for VB-Syntax (quotes doubled, if present):")
         .AddLine(txt.Replace("""", """""").Replace(CrLf, ""))
         LaunchEditorWith(.ToString)
      End With
   End Sub

   Private Sub CloneSampleRow()
      With Me.DTS.Sample
         Dim rwNew As SampleRow = .NewSampleRow
         Dim rwCurrent = SampleBindingSource.At(Of SampleRow)()
         For Each Clmn As DataColumn In .Columns
            If Not Clmn.Unique Then
               rwNew(Clmn) = rwCurrent(Clmn)
            End If
         Next
         .AddSampleRow(rwNew)
      End With
   End Sub

   Private Sub Parse()
      Dim ResultMatches As MatchCollection
      ClearOutput()
      'Regex-analyse ausfhren: a) Matches, b) Replacement
      OptionGrid.EndEdit()
      Dim opt = SampleBindingSource.At(Of SampleRow)().RgxOption.CastX(Of RegexOptions)()
      Try
         ResultMatches = Regex.Matches(Me.rtbToParse.Text, Me.rtbSearchpattern.OneLineText, opt)
         Me.rtbReplaceResult.Text = Regex.Replace( _
             Me.rtbToParse.Text, Me.rtbSearchpattern.OneLineText, Me.rtbReplacepattern.Text, opt)
      Catch ex As Exception
         NewMessageBox(ex.Message).Buttons(MessageBoxButtons.OK). _
             Caption("Fehler in regulrem Ausdruck").Show()
         Return
      End Try
      'Den SearchPattern auf Group-Definitionen hin auswerten
      Dim HierarchicalPattern As New HierarchicalRegexPattern
      HierarchicalPattern.Pattern(Me.rtbSearchpattern.OneLineText)
      Dim GroupInfos As List(Of clsGroupInfo) = HierarchicalPattern.Groupinfos
      'Treeview befllen - die Nodes reprsentieren Gruppen der Matches, halten aber auch
      '! Informationen (GroupInfos), welche Teilzeichenfolge des Searchpatterns die Match-Group
      '! definiert
      Me.tlvMatches.BeginUpdate()
      For iMatch As Integer = 0 To ResultMatches.Count - 1
         Dim ndGroup0 As New RegexTreeNode(Me.tlvMatches)
         ndGroup0.SetGroupInfo(GroupInfos, ResultMatches, iMatch, 0)
         For iGroup As Integer = 1 To GroupInfos.Count - 1
            RegexTreeNode.Create(ndGroup0).SetGroupInfo(GroupInfos, ResultMatches, iMatch, iGroup)
         Next
      Next
      Me.tlvMatches.EndUpdate()
      rtbSplitResult.Text = String.Join(Lf, Regex.Split(rtbToParse.Text, rtbSearchpattern.Text, opt).Select(Function(s) "" & s))
      'For Each mt As Match In ResultMatches
      '   Debug.WriteLine(mt.Value)
      '   Debug.Indent()
      '   For Each grp As Group In mt.Groups
      '      Debug.WriteLine(grp.Value)
      '      Debug.Indent()
      '      If grp.Captures.Count > 1 Then Stop
      '      For Each cap As Capture In grp.Captures
      '         Debug.WriteLine(cap.Value)
      '      Next
      '      Debug.Unindent()
      '   Next
      '   Debug.Unindent()
      'Next
   End Sub

   Private Sub Save()
      If Me.Validate() Then Me.DTS.WriteXml(Me.SaveFileDialog1.FileName)
   End Sub

   Private Sub Reload()
      Dim FileFullname As String = Me.SaveFileDialog1.FileName
      If File.Exists(FileFullname) Then
         Dim bs = SampleBindingSource
         SampleBindingSource = Nothing
         With Me.DTS
            Using .EventDisabler.Enter
               .EnforceConstraints = False
               .Clear()
               .ReadXml(FileFullname)
               .EnforceConstraints = True
            End Using
         End With
         SampleBindingSource = bs
         UpdateOptions(SampleBindingSource.At(Of SampleRow)())
      Else
         With NewMessageBox("File nicht gefunden:\n")
            .Owner(Me)
            .FormatLine("'{0}'", FileFullname)
            .FormatLine("Fortfahren (mit leerer Sample-Liste)?")
            .Buttons(MessageBoxButtons.OKCancel)
            If .Show = Windows.Forms.DialogResult.OK Then
               Me.DTS.Clear()
               DTS.RgxOption.InitOptions()
            Else
               Return
            End If
         End With
      End If
      Me.Text = FileFullname
   End Sub

   Private Sub frmRegexTester_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs)
      My.Settings.SampleFile = SaveFileDialog1.FileName
      My.Settings.Save()
      Save()
   End Sub

   Private Sub tlvMatches_AfterSelect(ByVal sender As Object, ByVal e As TreeViewEventArgs) _
         Handles tlvMatches.AfterSelect
      Dim Nd As RegexTreeNode = DirectCast(e.Node, RegexTreeNode)
      Me.rtbSearchpattern.SelectFromOneLineText(Nd.GroupInfo.Index, Nd.GroupInfo.Length)     'In den
      '!                                               SearchPattern die angewhlte Gruppe markieren
      Me.rtbToParse.Select(Nd.Group.Index, Nd.Group.Length)            'Im ToParse-Text den Match der
      '!                                                                angewhlten Gruppe markieren
   End Sub

   Private Sub ClearOutput()
      Me.tlvMatches.Nodes.Clear()
      Me.rtbReplaceResult.Clear()
   End Sub

   Private Sub UpdateOptions(ByVal rwSample As SampleRow)
      Using DTS.EventDisabler.Enter
         For Each rwOpt In DTS.RgxOption
            rwOpt.SampleRow = rwSample
            If rwSample.Null Then
               rwOpt.Checked = False
            Else
               Dim match = 0 <> (rwSample.RgxOption And rwOpt.Value)
               If rwOpt.Checked <> match Then rwOpt.Checked = match
            End If
         Next
      End Using
   End Sub

   Private Sub SampleBindingSource_CurrentChanged( _
         ByVal sender As Object, ByVal e As System.EventArgs) _
         Handles SampleBindingSource.CurrentChanged
      ClearOutput()
      Dim rwSample = SampleBindingSource.At(Of SampleRow)()
      UpdateOptions(rwSample)
   End Sub

End Class